# frozen_string_literal: true

require 'json'
require 'net/http'
require 'digest'

Dir["#{File.dirname(__FILE__)}/rewards/**/*.rb"].sort.each do |file|
  require file
end

module Sorare
  # Rewards gem root
  module Rewards
    class << self
      def configuration
        @configuration ||= Configuration.new
      end

      def configure
        yield(configuration)
      end
    end

    def self.pick(salt:, hash: nil, data: nil)
      allocation_ctx = Sorare::Rewards::Build.call!(data: data || game_week_data(hash), salt: salt)
      Sorare::Rewards::Pick.call!(allocation_ctx.to_h).picks
    end
  end
end
