# frozen_string_literal: true

module Sorare
  module Rewards
    # GameWeekAllocations stores the expected allocations for a game week
    class GameWeekAllocations
      attr_reader :allocations

      def initialize(allocations)
        @allocations = allocations
      end

      def each_league_allocations
        allocations.each_key do |league_name|
          return to_enum(:each_league_allocations) unless block_given?

          yield(league_name, allocations[league_name])
        end
      end

      def each_league_rarity_allocations
        each_league_allocations do |league_name, league_allocations|
          league_allocations.each_key do |rarity|
            return to_enum(:each_league_rarity_allocations) unless block_given?

            yield(league_name, rarity, league_allocations[rarity])
          end
        end
      end
    end
  end
end
