# frozen_string_literal: true

require 'active_support/concern'
require 'interactor'

module Sorare
  module Rewards
    # Interactor extends Interactor to improve on it
    module Interactor
      extend ActiveSupport::Concern

      included do
        include ::Interactor

        # make sure we fail the current context when a call! to another interactor fails
        around do |interactor|
          interactor.call
        rescue ::Interactor::Failure => e
          context.fail!(error: e.context.error)
        end
      end
    end
  end
end
