# frozen_string_literal: true

require 'active_support/core_ext/enumerable'

module Sorare
  module Rewards
    # Random serves as an extension of the default Random class to work with the salt and seed
    class Random < ::Random
      def initialize(seed, salt)
        super Digest::SHA256.hexdigest("#{seed}#{salt}").to_i(16)
      end
    end
  end
end
